#define AROS_ALMOST_COMPATIBLE
#include "global.h"

#define DEBUG 0
#include <aros/debug.h>

static const UBYTE coptions[] =
	"DoubleBuffer/S,"
	"TripleBuffer/S,"
	"IgnoreMemoryChecks/S,"
	"NoLoadBalancing/S,"
	"OpenWindowEffect/N,"
	"CloseWindowEffect/N,"
	"ActiveWindowEffect/N,"
	"InactiveWindowLevel/N,"
	"InactiveWindowEffect/N,"
	"/F";

struct Args
{
	ULONG DoubleBuffer;
	ULONG TripleBuffer;
	ULONG IgnoreMemoryChecks;
	ULONG NoLoadBalancing;
	ULONG *OpenWindowEffectSpeed;
	ULONG *CloseWindowEffectSpeed;
	ULONG *ActiveWindowEffectSpeed;
	ULONG *InactiveWindowOpacity;
	ULONG *InactiveWindowEffectSpeed;
	STRPTR FutureArgs;
};

void LoadCompositingPrefs(char *filename)
{
	BPTR file;
	ULONG tags[] =
	{
		IPAC_UseDoubleBugger, TRUE,
		IPAC_UseTripleBugger, TRUE,
		IPAC_IgnoreMemoryChecks, FALSE,
		IPAC_LoadBalancing, TRUE,
		TAG_DONE
	};

	if ((file = Open(filename,MODE_OLDFILE)))
	{
		BPTR OldFile;
		struct RDArgs rda;
		struct RDArgs *rda1;
		struct Args args;

		memset(&rda,0,sizeof(struct RDArgs));

		OldFile = Input();
		SelectInput(file);
		rda.RDA_Flags = RDAF_NOPROMPT | RDAF_STDIN;

		memset(&args,0,sizeof(args));

		if ((rda1 = ReadArgs(coptions, (LONG *)&args, &rda)))
		{
			struct LayerManagerSettings lms;

			tags[1] = args.DoubleBuffer ? TRUE : FALSE;
			tags[3] = args.TripleBuffer ? TRUE : FALSE;
			tags[5] = args.IgnoreMemoryChecks ? TRUE : FALSE;
			tags[7] = args.NoLoadBalancing ? FALSE : TRUE;

			lms.OpenWindowEffectSpeed = args.OpenWindowEffectSpeed ? *args.OpenWindowEffectSpeed : 0;
			lms.CloseWindowEffectSpeed = args.CloseWindowEffectSpeed ? *args.CloseWindowEffectSpeed : 0;
			lms.ActiveWindowEffectSpeed = args.ActiveWindowEffectSpeed ? *args.ActiveWindowEffectSpeed : 0;
			lms.InactiveWindowEffectSpeed = args.InactiveWindowEffectSpeed ? *args.InactiveWindowEffectSpeed : 0;
			lms.InactiveWindowOpacity = args.InactiveWindowOpacity ? *args.InactiveWindowOpacity : 100;
			
			SetIPrefs(&tags, 0, IP_COMPOSITINGTAGS);
			SetIPrefs(&lms, sizeof(lms), IP_LAYERMANAGER);

			FreeArgs(rda1);
		}

		SelectInput(OldFile);
		Close(file);
	}
}

